#!/usr/bin/env node
'use strict';
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = require("fs");
var path_1 = require("path");
var debug_helper_1 = require("./util/debug_helper");
var _a = debug_helper_1.default(__filename), print = _a.print, logError = _a.logError;
var _b = process.argv, arg = _b[2];
if (/-v.*/.test(arg)) {
    try {
        var _c = JSON.parse(fs_1.readFileSync(path_1.resolve(__dirname, '..', 'package.json')).toString()), name_1 = _c.name, version_1 = _c.version;
        console.log("    " + name_1 + " v" + version_1 + " \u2714\uFE0F");
    }
    catch (error) {
        logError({ error: error });
    }
    process.exit();
}
var qs_1 = require("qs");
var private_api_request_1 = require("./kraken/private_api_request");
var public_api_request_1 = require("./kraken/public_api_request");
var private_api_request_2 = require("./hitbtc/private_api_request");
var public_api_request_2 = require("./hitbtc/public_api_request");
var private_api_request_3 = require("./binance/private_api_request");
var public_api_request_3 = require("./binance/public_api_request");
var nodeMenu = require("node-menu");
var pkgPath = path_1.resolve(__dirname, '..', 'package.json');
var version = JSON.parse(fs_1.readFileSync(pkgPath).toString()).version;
var filterBalances = function (balancesArr) {
    var balances = balancesArr.filter(function (_a) {
        var available = _a.available, free = _a.free;
        return Number(available || free) > 0;
    });
    print({ balances: balances });
};
var handleUserInput = function (input, exchange, pOp) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, endpoint_1, rawParams_1, _b, _c, _d, endpoint, _e, method, rawParams, dataOrParams, _f, _g, _h, dataOrParams_1, _j, _k;
    return __generator(this, function (_l) {
        switch (_l.label) {
            case 0:
                if (!(exchange === 'kraken')) return [3 /*break*/, 5];
                _a = input.split(';'), endpoint_1 = _a[0], rawParams_1 = _a[1];
                if (!(pOp === 'public')) return [3 /*break*/, 2];
                _b = print;
                return [4 /*yield*/, public_api_request_1.krakenPublicApiRequest({ url: endpoint_1, data: qs_1.parse(rawParams_1) })];
            case 1:
                _b.apply(void 0, [_l.sent()]);
                return [3 /*break*/, 4];
            case 2:
                _c = print;
                return [4 /*yield*/, private_api_request_1.krakenPrivateApiRequest({ url: endpoint_1, data: qs_1.parse(rawParams_1) })];
            case 3:
                _c.apply(void 0, [_l.sent()]);
                _l.label = 4;
            case 4: return [2 /*return*/];
            case 5:
                _d = input.split(';'), endpoint = _d[0], _e = _d[1], method = _e === void 0 ? 'GET' : _e, rawParams = _d[2];
                dataOrParams = qs_1.parse(rawParams);
                _f = exchange;
                switch (_f) {
                    case 'binance': return [3 /*break*/, 6];
                    case 'hitbtc': return [3 /*break*/, 11];
                }
                return [3 /*break*/, 16];
            case 6:
                if (!(pOp === 'public')) return [3 /*break*/, 8];
                _g = print;
                return [4 /*yield*/, public_api_request_3.binancePublicApiRequest({ url: endpoint, method: method, data: dataOrParams, params: dataOrParams })];
            case 7:
                _g.apply(void 0, [_l.sent()]);
                return [3 /*break*/, 10];
            case 8:
                _h = print;
                return [4 /*yield*/, private_api_request_3.binancePrivateApiRequest({ url: endpoint, method: method, data: dataOrParams, params: dataOrParams })];
            case 9:
                _h.apply(void 0, [_l.sent()]);
                _l.label = 10;
            case 10: return [2 /*return*/];
            case 11:
                if (!(pOp === 'public')) return [3 /*break*/, 13];
                dataOrParams_1 = qs_1.parse(rawParams);
                _j = print;
                return [4 /*yield*/, public_api_request_2.hitbtcPublicApiRequest({ url: endpoint, method: method, data: dataOrParams_1, params: dataOrParams_1 })];
            case 12:
                _j.apply(void 0, [_l.sent()]);
                return [3 /*break*/, 15];
            case 13:
                _k = print;
                return [4 /*yield*/, private_api_request_2.hitbtcPrivateApiRequest({ url: endpoint, method: method, data: dataOrParams, params: dataOrParams })];
            case 14:
                _k.apply(void 0, [_l.sent()]);
                _l.label = 15;
            case 15: return [2 /*return*/];
            case 16: return [2 /*return*/];
        }
    });
}); };
nodeMenu
    .customHeader(function () {
    process.stdout.write("                              <<<<<<     TS-CRYPTO-CLI v" + version + "     >>>>>>\n\n");
})
    .addDelimiter('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n#    Kraken API | https://www.kraken.com/features/api#general-usage\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~', 2)
    .addItem('PUBLIC API request', function (input) { handleUserInput(input, 'kraken', 'public'); }, null, [{ name: '<endpoint>;<query>', type: 'string' }])
    .addItem('PRIVATE API request', function (input) { handleUserInput(input, 'kraken', 'private'); }, null, [{ name: '<endpoint>;<query>', type: 'string' }])
    .addItem('Show Balances', function () { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, private_api_request_1.krakenPrivateApiRequest({ url: 'Balance' })];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); })
    .addItem('BUY @ market', function (pair, volume) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, private_api_request_1.krakenPrivateApiRequest({ url: 'AddOrder', data: { pair: pair, type: 'buy', ordertype: 'market', volume: volume } })];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: 'pair', type: 'string' }, { name: 'amount', type: 'numeric' }])
    .addItem('SELL @ market', function (pair, volume) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, private_api_request_1.krakenPrivateApiRequest({ url: 'AddOrder', data: { pair: pair, type: 'sell', ordertype: 'market', volume: volume } })];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: 'pair', type: 'string' }, { name: 'amount', type: 'numeric' }])
    .addItem('Set Kraken API key/secret', function (key, secret) { process.env.KRAKEN_API_KEY = key; process.env.KRAKEN_API_SECRET = secret; }, null, [{ name: '<API_KEY>', type: 'string' }, { name: '<API_SECRET>', type: 'string' }])
    .addDelimiter(' ', 1)
    .addDelimiter('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n#    HitBTC API | https://api.hitbtc.com/#rest-api-reference\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~', 2)
    .addItem('PUBLIC API request', function (input) { handleUserInput(input, 'hitbtc', 'public'); }, null, [{ name: '<endpoint>;<method>;<query>', type: 'string' }])
    .addItem('PRIVATE API request', function (input) { handleUserInput(input, 'hitbtc', 'private'); }, null, [{ name: '<endpoint>;<method>;<query>', type: 'string' }])
    .addItem('Show ACCOUNT Balances', function () { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = filterBalances;
            return [4 /*yield*/, private_api_request_2.hitbtcPrivateApiRequest({ url: 'account/balance' })];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); })
    .addItem('Show TRADING Balances', function () { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = filterBalances;
            return [4 /*yield*/, private_api_request_2.hitbtcPrivateApiRequest({ url: 'trading/balance' })];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); })
    .addItem('BUY @ market', function (symbol, quantity) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, private_api_request_2.hitbtcPrivateApiRequest({ url: 'order', method: 'POST', data: { symbol: symbol, side: 'buy', type: 'market', quantity: quantity } })];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: 'pair', type: 'string' }, { name: 'amount', type: 'numeric' }])
    .addItem('SELL @ market', function (symbol, quantity) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, private_api_request_2.hitbtcPrivateApiRequest({ url: 'order', method: 'POST', data: { symbol: symbol, side: 'sell', type: 'market', quantity: quantity } })];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: 'pair', type: 'string' }, { name: 'amount', type: 'numeric' }])
    .addItem('Set HitBTC API key/secret', function (key, secret) { process.env.HITBTC_API_KEY = key; process.env.HITBTC_API_SECRET = secret; }, null, [{ name: '<API_KEY>', type: 'string' }, { name: '<API_SECRET>', type: 'string' }])
    .addDelimiter(' ', 1)
    .addDelimiter('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n#    Binance API | https://binance-docs.github.io/apidocs/spot/en/#general-api-information\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~', 2)
    .addItem('PUBLIC API request', function (input) { handleUserInput(input, 'binance', 'public'); }, null, [{ name: '<endpoint>;<method>;<query>', type: 'string' }])
    .addItem('PRIVATE API request', function (input) { handleUserInput(input, 'binance', 'private'); }, null, [{ name: '<endpoint>;<method>;<query>', type: 'string' }])
    .addItem('Show Balances', function () { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = filterBalances;
            return [4 /*yield*/, private_api_request_3.binancePrivateApiRequest({ url: 'api/v3/account' })];
        case 1:
            _a.apply(void 0, [(_b.sent()).balances]);
            return [2 /*return*/];
    }
}); }); })
    .addItem('BUY @ market', function (symbol, quantity) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, private_api_request_3.binancePrivateApiRequest({ url: 'api/v3/order', method: 'POST', data: { symbol: symbol, side: 'buy', type: 'market', quantity: quantity } })];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: 'pair', type: 'string' }, { name: 'amount', type: 'numeric' }])
    .addItem('SELL @ market', function (symbol, quantity) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, private_api_request_3.binancePrivateApiRequest({ url: 'api/v3/order', method: 'POST', data: { symbol: symbol, side: 'sell', type: 'market', quantity: quantity } })];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: 'pair', type: 'string' }, { name: 'amount', type: 'numeric' }])
    .addItem('Set Binance API key/secret', function (key, secret) { process.env.BINANCE_API_KEY = key; process.env.BINANCE_API_SECRET = secret; }, null, [{ name: '<API_KEY>', type: 'string' }, { name: '<API_SECRET>', type: 'string' }])
    .addDelimiter(' ', 1)
    .addDelimiter('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n#    Extras/Config\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~', 2)
    .addItem('Print current env', function () { var env = process.env; print({ env: env }); })
    .addItem('Set env value', function (key, val) { process.env[key] = val; }, null, [{ name: 'key', type: 'string' }, { name: 'value', type: 'string' }])
    .addDelimiter(' ', 1)
    .customPrompt(function () {
    process.stdout.write('\nEnter your selection:\n');
})
    .continueCallback(function () {
    // Runs between 'Press enter to continue' and the new menu render
})
    .start();
